// Generated by CoffeeScript 1.6.2
(function() {
  var JSHintLinter, formatError, jshint;

  jshint = require('jshint').JSHINT;

  formatError = function(error) {
    var evidence;

    evidence = (error.evidence ? "\n\n" + error.evidence + "\n" : '\n');
    return "" + error.reason + " " + (error.id || '') + " at line " + error.line + ", column " + error.character;
  };

  module.exports = JSHintLinter = (function() {
    JSHintLinter.prototype.brunchPlugin = true;

    JSHintLinter.prototype.type = 'javascript';

    JSHintLinter.prototype.extension = 'js';

    function JSHintLinter(config) {
      var cfg, _ref, _ref1, _ref2;

      this.config = config;
      cfg = (_ref = (_ref1 = this.config) != null ? _ref1.jshint : void 0) != null ? _ref : {};
      this.options = cfg.options;
      this.globals = cfg.globals;
      this.pattern = (_ref2 = cfg.pattern) != null ? _ref2 : RegExp("^" + this.config.paths.app + ".*\\.js$");
    }

    JSHintLinter.prototype.lint = function(data, path, callback) {
      var error, success;

      success = jshint(data, this.options, this.globals);
      if (success) {
        return callback();
      } else {
        error = jshint.errors.filter(function(error) {
          return error != null;
        }).map(formatError).join('\n');
        return callback(error);
      }
    };

    return JSHintLinter;

  })();

}).call(this);
